function Q = CinInvHip_Sup( P,L )

 %-- L=[l0 l1 l2 l3 l4 l5 l5h l5t l6] -------------------------------------
  l0 = L(1); l1 = L(2); l2 = L(3); l3 = L(4); l4 = L(5); 
  l5 = L(6); l5h = L(7); l5t = L(8); l6 = L(9);
  
 %-- Junta lateral do tornozelo -------------------------------------------
  xh  = P(1);  yh = P(2);  zh = P(3); 
  ang1 = atan2(-yh+l6/2,(zh-l0-l5-l5h/2));  
 %-- Restriao cinematica: anca&tornozelo vertical ------------------------  
  x1  = 0;      y1 = -l1*sin(ang1);             z1 = l0+l1*cos(ang1); 
  x2  = P(1);   y2 = P(2)-l6/2-l4*sin(-ang1);   z2 = P(3)-l5h/2-l5-l4*cos(-ang1);   
 %-- Transformaao de coordenadas : plano do movimento --------------------
  Ye = x2; 
  if (ang1 > pi/4 & ang1 < 3*pi/4) | (ang1 < -pi/4 & ang1 > -3*pi/4)
      Xe = -(y2-y1)/sin(ang1);
  else
      Xe = (z2-z1)/cos(ang1);
  end
  
 %-- Junta sagital do tornozelo -------------------------------------------
  K1 = 2*l2*Ye;
  K2 = 2*l2*Xe;
  K3 = Xe^2+Ye^2+l2^2-l3^2;
  KK_aux = K1^2+K2^2-K3^2;
  if KK_aux < 0, disp('ERROR MSG: function CinInv12R'), pause, return, end
  ang2 = atan2(K1,K2)+atan2(sqrt(K1^2+K2^2-K3^2),K3);
  %-- ngulo entre -pi e pi -----------------------------------------------
  if ang2 >  pi,    ang2 = ang2-2*pi;   end
  if ang2 < -pi,    ang2 = ang2+2*pi;   end
  
 %-- Junta do joelho ------------------------------------------------------
  K1 = 0;
  K2 = 2*l2*l3;
  K3 = Xe^2+Ye^2-l2^2-l3^2;
  KK_aux = K2^2-K3^2;
  if KK_aux < 0, disp('ERROR MSG: function CinInv12R'), pause, return, end
  ang3 = -atan2(sqrt(K2^2-K3^2),K3);
     
 %-- Juntas da anca -------------------------------------------------------
  ang4 = -ang2-ang3; 
  ang5 = -ang1;
  ang6 = 0;
 %-----------------------------------------------------------------endCASE1
%-- Vector de juntas ------------------------------------------------------
 Q = [ ang1 ang2 ang3 ang4 ang5 ang6 ];
%-----------------------------------------------------------------------end
